import React, { Component } from "react";
import ReactDOM from "react-dom";
import _ from "lodash";

import { createStore, applyMiddleware, combineReducers, compose } from "redux";
import { Provider, connect } from "react-redux";
// import { Form, Control, Errors, combineForms, actions } from 'react-redux-form'
import thunk from "redux-thunk";
import createLogger from "redux-logger";
// import RxForm from 'rxform';

// console.log(RxForm);

const logger = createLogger();

import {
  Field,
  Fieldset,
  Errors,
  Control,
  Form,
  LocalForm,
  combineForms,
  actions,
  formReducer,
  modeled,
  controls
} from "react-redux-form";

// ========================================
// ========================================

const initialUserState = {};
const middlewares = [thunk, logger];
const store = createStore(
  combineForms({
    user: {
      '2345': {}
    }
  }),
  applyMiddleware(...middlewares)
);

class UserForm extends Component {
  render() {
    const id = '2345';
    return (
      <Form
        model={`user.${id}`}
        onSubmit={v => console.log(v)}
        validateOn="submit"
        validators={{
          firstName: { isRequired: val => val && val.length },
          lastName: { isRequired: val => val && val.length }
        }}
      >
        <div className="field">
          <label>First name:</label>
          <Control.text
            validators={{
              vval: val => {
                console.log(val, 'validators');
              }
            }}
            asyncValidators={{
              val: val => {
                console.log(val, 'async');
              }
            }}
            asyncValidateOn="change"
            model=".firstName"
          />
          <Errors
            model=".firstName"
            show={{ pristine: true }}
            messages={{
              isRequired: 'Firstname is mandatory.'
            }}
          />
        </div>

        <div className="field">
          <label>Last name:</label>
          <Control.text model=".lastName" />
          <Errors
            model=".lastName"
            show={{ pristine: true }}
            messages={{
              isRequired: 'lastName is mandatory'
            }}
          />
        </div>

        <button type="submit">Submit (check console)</button>
      </Form>
    );
  }
}

class App extends React.Component {
  render() {
    return (
      <Provider store={store}>
        <UserForm />
      </Provider>
    );
  }
}

ReactDOM.render(<App />, document.getElementById('app'));
